(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/animations'), require('@angular/common'), require('@angular/platform-browser/animations')) :
    typeof define === 'function' && define.amd ? define('ngx-dynamic-carousel', ['exports', '@angular/core', '@angular/animations', '@angular/common', '@angular/platform-browser/animations'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ngx-dynamic-carousel'] = {}, global.ng.core, global.ng.animations, global.ng.common, global.ng.platformBrowser.animations));
}(this, (function (exports, i0, animations, i1, animations$1) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () {
                            return e[k];
                        }
                    });
                }
            });
        }
        n['default'] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);

    var NgxDynamicCarouselService = /** @class */ (function () {
        function NgxDynamicCarouselService() {
        }
        return NgxDynamicCarouselService;
    }());
    NgxDynamicCarouselService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: NgxDynamicCarouselService, deps: [], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    NgxDynamicCarouselService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: NgxDynamicCarouselService, providedIn: 'root' });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: NgxDynamicCarouselService, decorators: [{
                type: i0.Injectable,
                args: [{
                        providedIn: 'root'
                    }]
            }], ctorParameters: function () { return []; } });

    var fadeIn = animations.animation([
        animations.style({ opacity: 0 }),
        animations.animate('2s', animations.style({ opacity: 1 }))
    ]);
    var scaleIn = animations.animation([
        animations.style({ opacity: 0, transform: "scale(0.5)" }),
        animations.animate('2s', animations.style({ opacity: 1, transform: "scale(1)" }))
    ]);
    var NgxDynamicCarouselComponent = /** @class */ (function () {
        function NgxDynamicCarouselComponent() {
            this.items = [];
            this.animationState = 'fade';
            this.visibleCount = 1;
            this.firstIndex = 0;
            this.lastIndex = this.visibleCount - 1;
        }
        NgxDynamicCarouselComponent.prototype.ngOnInit = function () {
        };
        NgxDynamicCarouselComponent.prototype.ngOnChanges = function (changes) {
            this.lastIndex = (changes === null || changes === void 0 ? void 0 : changes.visibleCount.currentValue) - 1;
        };
        NgxDynamicCarouselComponent.prototype.right = function () {
            this.firstIndex = this.firstIndex + 1;
            this.lastIndex = this.lastIndex + 1;
        };
        NgxDynamicCarouselComponent.prototype.left = function () {
            this.firstIndex = this.firstIndex - 1;
            this.lastIndex = this.lastIndex - 1;
        };
        NgxDynamicCarouselComponent.prototype.trackByFn = function () {
            return Math.random();
        };
        return NgxDynamicCarouselComponent;
    }());
    NgxDynamicCarouselComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: NgxDynamicCarouselComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    NgxDynamicCarouselComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.0.0", type: NgxDynamicCarouselComponent, selector: "ngx-dynamic-carousel", inputs: { mainContentTemplate: "mainContentTemplate", leftArrowTemplate: "leftArrowTemplate", rightArrowtemplate: "rightArrowtemplate", items: "items", animationState: "animationState", visibleCount: "visibleCount" }, usesOnChanges: true, ngImport: i0__namespace, template: "<div class=\"flex items-center justify-around\">\n    <div [class.disabled]=\"firstIndex == 0\" (click)=\"left()\">\n        <ng-container *ngTemplateOutlet=\"leftArrowTemplate ? leftArrowTemplate : defaultLeftArrowTemplate\">\n        </ng-container>\n        <ng-template #defaultLeftArrowTemplate>\n            <- </ng-template>\n    </div>\n    <div *ngFor=\"let item of items.slice(firstIndex, lastIndex + 1); index as i; trackBy: trackByFn\" [@animationTrigger]=\"animationState\">\n        <ng-template [ngTemplateOutlet]=\"mainContentTemplate\" [ngTemplateOutletContext]=\"{ $implicit: item }\">\n        </ng-template>\n    </div>\n\n    <div [class.disabled]=\"lastIndex == items.length - 1\" (click)=\"right()\">\n        <ng-container *ngTemplateOutlet=\"rightArrowtemplate ? rightArrowtemplate : defaultRightArrowTemplate\">\n        </ng-container>\n        <ng-template #defaultRightArrowTemplate>-></ng-template>\n    </div>\n</div>", styles: ["\n    .disabled {\n      pointer-events: none;\n      opacity: 50%\n    }\n    "], directives: [{ type: i1__namespace.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: i1__namespace.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }], animations: [
            animations.trigger('animationTrigger', [
                animations.transition('void=>scale', [
                    animations.useAnimation(scaleIn)
                ]),
                animations.transition('void=>fade', [
                    animations.useAnimation(fadeIn)
                ]),
            ]),
        ] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: NgxDynamicCarouselComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'ngx-dynamic-carousel',
                        templateUrl: './ngx-dynamic-carousel.component.html',
                        styles: [
                            "\n    .disabled {\n      pointer-events: none;\n      opacity: 50%\n    }\n    "
                        ],
                        animations: [
                            animations.trigger('animationTrigger', [
                                animations.transition('void=>scale', [
                                    animations.useAnimation(scaleIn)
                                ]),
                                animations.transition('void=>fade', [
                                    animations.useAnimation(fadeIn)
                                ]),
                            ]),
                        ]
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { mainContentTemplate: [{
                    type: i0.Input
                }], leftArrowTemplate: [{
                    type: i0.Input
                }], rightArrowtemplate: [{
                    type: i0.Input
                }], items: [{
                    type: i0.Input
                }], animationState: [{
                    type: i0.Input
                }], visibleCount: [{
                    type: i0.Input
                }] } });

    var NgxDynamicCarouselModule = /** @class */ (function () {
        function NgxDynamicCarouselModule() {
        }
        return NgxDynamicCarouselModule;
    }());
    NgxDynamicCarouselModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: NgxDynamicCarouselModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    NgxDynamicCarouselModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: NgxDynamicCarouselModule, declarations: [NgxDynamicCarouselComponent], imports: [i1.CommonModule,
            animations$1.BrowserAnimationsModule], exports: [NgxDynamicCarouselComponent] });
    NgxDynamicCarouselModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: NgxDynamicCarouselModule, imports: [[
                i1.CommonModule,
                animations$1.BrowserAnimationsModule
            ]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: NgxDynamicCarouselModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            NgxDynamicCarouselComponent,
                        ],
                        imports: [
                            i1.CommonModule,
                            animations$1.BrowserAnimationsModule
                        ],
                        exports: [
                            NgxDynamicCarouselComponent,
                        ]
                    }]
            }] });

    /*
     * Public API Surface of ngx-dynamic-carousel
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NgxDynamicCarouselComponent = NgxDynamicCarouselComponent;
    exports.NgxDynamicCarouselModule = NgxDynamicCarouselModule;
    exports.NgxDynamicCarouselService = NgxDynamicCarouselService;
    exports.fadeIn = fadeIn;
    exports.scaleIn = scaleIn;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-dynamic-carousel.umd.js.map
