import * as i0 from '@angular/core';
import { Injectable, Component, Input, NgModule } from '@angular/core';
import { animation, style, animate, trigger, transition, useAnimation } from '@angular/animations';
import * as i1 from '@angular/common';
import { CommonModule } from '@angular/common';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';

class NgxDynamicCarouselService {
    constructor() { }
}
NgxDynamicCarouselService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0, type: NgxDynamicCarouselService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
NgxDynamicCarouselService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0, type: NgxDynamicCarouselService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0, type: NgxDynamicCarouselService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

const fadeIn = animation([
    style({ opacity: 0 }),
    animate('2s', style({ opacity: 1 }))
]);
const scaleIn = animation([
    style({ opacity: 0, transform: "scale(0.5)" }),
    animate('2s', style({ opacity: 1, transform: "scale(1)" }))
]);
class NgxDynamicCarouselComponent {
    constructor() {
        this.items = [];
        this.animationState = 'fade';
        this.visibleCount = 1;
        this.firstIndex = 0;
        this.lastIndex = this.visibleCount - 1;
    }
    ngOnInit() {
    }
    ngOnChanges(changes) {
        this.lastIndex = (changes === null || changes === void 0 ? void 0 : changes.visibleCount.currentValue) - 1;
    }
    right() {
        this.firstIndex = this.firstIndex + 1;
        this.lastIndex = this.lastIndex + 1;
    }
    left() {
        this.firstIndex = this.firstIndex - 1;
        this.lastIndex = this.lastIndex - 1;
    }
    trackByFn() {
        return Math.random();
    }
}
NgxDynamicCarouselComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0, type: NgxDynamicCarouselComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NgxDynamicCarouselComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.0.0", type: NgxDynamicCarouselComponent, selector: "ngx-dynamic-carousel", inputs: { mainContentTemplate: "mainContentTemplate", leftArrowTemplate: "leftArrowTemplate", rightArrowtemplate: "rightArrowtemplate", items: "items", animationState: "animationState", visibleCount: "visibleCount" }, usesOnChanges: true, ngImport: i0, template: "<div class=\"flex items-center justify-around\">\n    <div [class.disabled]=\"firstIndex == 0\" (click)=\"left()\">\n        <ng-container *ngTemplateOutlet=\"leftArrowTemplate ? leftArrowTemplate : defaultLeftArrowTemplate\">\n        </ng-container>\n        <ng-template #defaultLeftArrowTemplate>\n            <- </ng-template>\n    </div>\n    <div *ngFor=\"let item of items.slice(firstIndex, lastIndex + 1); index as i; trackBy: trackByFn\" [@animationTrigger]=\"animationState\">\n        <ng-template [ngTemplateOutlet]=\"mainContentTemplate\" [ngTemplateOutletContext]=\"{ $implicit: item }\">\n        </ng-template>\n    </div>\n\n    <div [class.disabled]=\"lastIndex == items.length - 1\" (click)=\"right()\">\n        <ng-container *ngTemplateOutlet=\"rightArrowtemplate ? rightArrowtemplate : defaultRightArrowTemplate\">\n        </ng-container>\n        <ng-template #defaultRightArrowTemplate>-></ng-template>\n    </div>\n</div>", styles: ["\n    .disabled {\n      pointer-events: none;\n      opacity: 50%\n    }\n    "], directives: [{ type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }], animations: [
        trigger('animationTrigger', [
            transition('void=>scale', [
                useAnimation(scaleIn)
            ]),
            transition('void=>fade', [
                useAnimation(fadeIn)
            ]),
        ]),
    ] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0, type: NgxDynamicCarouselComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngx-dynamic-carousel',
                    templateUrl: './ngx-dynamic-carousel.component.html',
                    styles: [
                        `
    .disabled {
      pointer-events: none;
      opacity: 50%
    }
    `
                    ],
                    animations: [
                        trigger('animationTrigger', [
                            transition('void=>scale', [
                                useAnimation(scaleIn)
                            ]),
                            transition('void=>fade', [
                                useAnimation(fadeIn)
                            ]),
                        ]),
                    ]
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { mainContentTemplate: [{
                type: Input
            }], leftArrowTemplate: [{
                type: Input
            }], rightArrowtemplate: [{
                type: Input
            }], items: [{
                type: Input
            }], animationState: [{
                type: Input
            }], visibleCount: [{
                type: Input
            }] } });

class NgxDynamicCarouselModule {
}
NgxDynamicCarouselModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0, type: NgxDynamicCarouselModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgxDynamicCarouselModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0, type: NgxDynamicCarouselModule, declarations: [NgxDynamicCarouselComponent], imports: [CommonModule,
        BrowserAnimationsModule], exports: [NgxDynamicCarouselComponent] });
NgxDynamicCarouselModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0, type: NgxDynamicCarouselModule, imports: [[
            CommonModule,
            BrowserAnimationsModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0, type: NgxDynamicCarouselModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        NgxDynamicCarouselComponent,
                    ],
                    imports: [
                        CommonModule,
                        BrowserAnimationsModule
                    ],
                    exports: [
                        NgxDynamicCarouselComponent,
                    ]
                }]
        }] });

/*
 * Public API Surface of ngx-dynamic-carousel
 */

/**
 * Generated bundle index. Do not edit.
 */

export { NgxDynamicCarouselComponent, NgxDynamicCarouselModule, NgxDynamicCarouselService, fadeIn, scaleIn };
//# sourceMappingURL=ngx-dynamic-carousel.js.map
